stages:
  - build
  - security
  - deploy
  - post-release

include:
  - project: outcloud-gitlab/formacao/jobs
    ref: main
    file: dependency-check.yml
  - project: outcloud-gitlab/formacao/jobs
    ref: main
    file: sitespeed.yml

.base:
  tags:
    - findmore
    - outcloud
  parallel:
    matrix:
      - ENV: dev
        ENV_BRANCH: develop
      - ENV: prd
        ENV_BRANCH: main
  rules:
    - if: $CI_COMMIT_BRANCH == $ENV_BRANCH

read terraform:
  stage: build
  extends: .base
  image:
    name: hashicorp/terraform:1.4.5
    entrypoint: [""]
  variables:
    TF_VAR_student_name: lucas-fleming
    TF_VAR_environment: $ENV
  before_script:
    - terraform init
  script:
    - terraform apply -auto-approve
    - terraform output -raw primary_blob_connection_string > connection-string
    - terraform output -raw app_url > app-url
  cache:
    - key: connection-string-$ENV
      policy: push
      paths:
        - connection-string
    - key: app-url-$ENV
      policy: push
      paths:
        - app-url


build app:
  stage: build
  extends: .base
  image:
    name: node:20-alpine3.16
    entrypoint: [""]
  script:
    - cd outcloud-react
    - yarn
    - yarn build
  cache:
    - key: build-$ENV
      policy: push
      paths:
        - outcloud-react/build

dependency check:
  extends: .base
  allow_failure: true
  rules:
    - if: $CI_COMMIT_BRANCH == $ENV_BRANCH || ($CI_PIPELINE_SOURCE == "merge_request_event" && $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $ENV_BRANCH)

deploy app:
  stage: deploy
  extends: .base
  image: mcr.microsoft.com/azure-cli:latest
  script:
    - AZ_CONNECTION_STRING=$(cat connection-string)
    - az storage blob delete-batch -s "\$web" --connection-string $AZ_CONNECTION_STRING
    - az storage blob upload-batch -d "\$web" -s outcloud-react/build --connection-string $AZ_CONNECTION_STRING
  cache:
    - key: connection-string-$ENV
      policy: pull
      paths:
        - connection-string
    - key: build-$ENV
      policy: pull
      paths:
        - outcloud-react/build
  when: manual

sitespeed:
  extends: .base
  needs:
    - job: deploy app
      optional: true
  allow_failure: true
  cache:
    - key: app-url-$ENV
      policy: pull
      paths:
        - app-url
  before_script:
    - URL=$(cat app-url)
